Package: shinycssloaders
Title: Add Loading Animations to a 'shiny' Output While It's
        Recalculating
Version: 1.1.0
Authors@R: c(
    person("Dean","Attali",email="daattali@gmail.com",role=c("aut","cre"),
        comment = c("Maintainer/developer of shinycssloaders since 2019", ORCID="0000-0002-5645-3493")),
    person("Andras","Sali",email="andras.sali@alphacruncher.hu",role=c("aut"),comment="Original creator of shinycssloaders package"),
    person("Luke","Hass",role=c("ctb","cph"),comment="Author of included CSS loader code")
    )
Description: When a 'Shiny' output (such as a plot, table, map, etc.) is recalculating, it remains 
    visible but gets greyed out. Using 'shinycssloaders', you can add a loading animation ("spinner")
    to outputs instead. By wrapping a 'Shiny' output in 'withSpinner()', a spinner will automatically
    appear while the output is recalculating. You can also manually show and hide the spinner, or add
    a full-page spinner to cover the entire page.
    See the demo online at <https://daattali.com/shiny/shinycssloaders-demo/>.
License: MIT + file LICENSE
URL: https://github.com/daattali/shinycssloaders,
        https://daattali.com/shiny/shinycssloaders-demo/
BugReports: https://github.com/daattali/shinycssloaders/issues
Depends: R (>= 3.1)
Imports: digest, glue, grDevices, htmltools (>= 0.3.5), shiny
Suggests: knitr, shinydisconnect, shinyjs
RoxygenNote: 7.2.3
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2024-07-30 18:52:48 UTC; Dean
Author: Dean Attali [aut, cre] (Maintainer/developer of shinycssloaders since
    2019, <https://orcid.org/0000-0002-5645-3493>),
  Andras Sali [aut] (Original creator of shinycssloaders package),
  Luke Hass [ctb, cph] (Author of included CSS loader code)
Maintainer: Dean Attali <daattali@gmail.com>
Repository: CRAN
Date/Publication: 2024-07-30 22:30:02 UTC

<h3 align="center">shinycssloaders</h3>
<h4 align="center">
  ⌛ Add loading animations to a Shiny output while it's recalculating
</h4>

<p align="center">
  <a href="https://github.com/daattali/shinycssloaders/actions/workflows/R-CMD-check.yaml">
    <img src="https://github.com/daattali/shinycssloaders/actions/workflows/R-CMD-check.yaml/badge.svg" alt="R-CMD-check" />
  </a> 
  <a href="https://cran.r-project.org/package=shinycssloaders">
    <img src="http://www.r-pkg.org/badges/version/shinycssloaders" alt="CRAN version" />
  </a>
</p>

---

When a Shiny output (such as a plot, table, map, etc.) is recalculating, it remains visible but gets greyed out. Using {shinycssloaders}, you can add a loading animation ("spinner") to outputs instead of greying them out. By wrapping a Shiny output in `withSpinner()`, a spinner will automatically appear while the output is recalculating. You can also manually trigger a spinner using `showSpinner()`.

In addition to showing spinners on outputs, you can also use `showPageSpinner()` to show a full-page spinner that covers the entire page.

You can choose from one of 8 built-in animation types, and customize the colour/size. You can also use your own image instead of the built-in animations. See the [demo Shiny app](https://daattali.com/shiny/shinycssloaders-demo/) online for examples.

**Need Shiny help? [I'm available for consulting](https://attalitech.com/).**<br/>
**If you find {shinycssloaders} useful, please consider [supporting my work](https://github.com/sponsors/daattali)! ❤**

<p align="center">
  <a style="display: inline-block;" href="https://github.com/sponsors/daattali">
    <img height="35" src="https://i.imgur.com/034B8vq.png" />
  </a>
</p>

> This package is part of a larger ecosystem of packages with a shared vision: solving common Shiny issues and improving Shiny apps with minimal effort, minimal code changes, and clear documentation. Other packages for your Shiny apps:

| Package | Description | Demo |
|---|---|---|
| [shinyjs](https://deanattali.com/shinyjs/) | 💡 Easily improve the user experience of your Shiny apps in seconds | [🔗](https://deanattali.com/shinyjs/overview#demo) |
| [shinyalert](https://github.com/daattali/shinyalert/) | 🗯️ Easily create pretty popup messages (modals) in Shiny | [🔗](https://daattali.com/shiny/shinyalert-demo/) |
| [shinyscreenshot](https://github.com/daattali/shinyscreenshot/) | 📷 Capture screenshots of entire pages or parts of pages in Shiny apps | [🔗](https://daattali.com/shiny/shinyscreenshot-demo/) |
| [timevis](https://github.com/daattali/timevis/) | 📅 Create interactive timeline visualizations in R | [🔗](https://daattali.com/shiny/timevis-demo/) |
| [colourpicker](https://github.com/daattali/colourpicker/) | 🎨 A colour picker tool for Shiny and for selecting colours in plots | [🔗](https://daattali.com/shiny/colourInput/) |
| [shinybrowser](https://github.com/daattali/shinybrowser/) | 🌐 Find out information about a user's web browser in Shiny apps | [🔗](https://daattali.com/shiny/shinybrowser-demo/) |
| [shinydisconnect](https://github.com/daattali/shinydisconnect/) | 🔌 Show a nice message when a Shiny app disconnects or errors | [🔗](https://daattali.com/shiny/shinydisconnect-demo/) |
| [shinytip](https://github.com/daattali/shinytip/) | 💬 Simple flexible tooltips for Shiny apps | WIP |
| [shinymixpanel](https://github.com/daattali/shinymixpanel/) | 🔍 Track user interactions with Mixpanel in Shiny apps or R scripts | WIP |
| [shinyforms](https://github.com/daattali/shinyforms/) | 📝 Easily create questionnaire-type forms with Shiny | WIP |

# Table of contents

- [Example](#example)
- [How to use](#usage)
- [Installation](#install)
- [Features](#features)
- [Sponsors 🏆](#sponsors)

<h2 id="example">Example</h2>

For interactive examples and to see some of the features, [check out the demo app](https://daattali.com/shiny/shinycssloaders-demo/).

Below is a simple example of what {shinycssloaders} looks like:

![demo GIF](inst/img/demo.gif)

<h2 id="usage">How to use</h2>

Simply wrap a Shiny output in a call to `withSpinner()`. If you have `%>%` loaded, you can use it, for example `plotOutput("myplot") %>% withSpinner()`.

Basic usage:

```r
library(shiny)

ui <- fluidPage(
    actionButton("go", "Go"),
    shinycssloaders::withSpinner(
        plotOutput("plot")
    )
)
server <- function(input, output) {
    output$plot <- renderPlot({
        input$go
        Sys.sleep(1.5)
        plot(runif(10))
    })
}
shinyApp(ui, server)
```

Using a full-page spinner:

```r
library(shiny)

ui <- fluidPage(
    actionButton("go", "Go"),
    plotOutput("plot")
)
server <- function(input, output) {
    observeEvent(input$go, {
      showPageSpinner()
      Sys.sleep(1)
      hidePageSpinner()
    })
    output$plot <- renderPlot({
        plot(runif(10))
    })
}
shinyApp(ui, server)
```

You can also use {shinycssloaders} in Rmarkdown documents, as long as they use `runtime: shiny`.

<h2 id="install">Installation</h2>

**For most users:** To install the stable CRAN version:

```
install.packages("shinycssloaders")
```

**For advanced users:** To install the latest development version from GitHub:

```
install.packages("remotes")
remotes::install_github("daattali/shinycssloaders")
```

<h2 id="features">Features</h2>

### 8 customizable built-in spinners

You can use the `type` parameter to choose one of the 8 built-in animations, the `color` parameter to change the spinner's colour, and `size` to make the spinner smaller or larger (2 will make the spinner twice as large). For example, `withSpinner(plotOutput("myplot"), type = 5, color = "#0dc5c1", size = 2)`. 

### Using a custom image

If you don't want to use any of the built-in spinners, you can also provide your own image (either a still image or a GIF) to use instead, using the `image` parameter.

### Specifying the spinner height

The spinner attempts to automatically figure out the height of the output it replaces, and to vertically center itself. For some outputs (such as tables), the height is unknown, so the spinner will assume the output is 400px tall. If your output is expected to be significantly smaller or larger, you can use the `proxy.height` parameter to adjust this.

### Manually triggering the spinner

Any Shiny output that uses `withSpinner()` will automatically show a spinner while it's recalculating. You can also manually show/hide an output's spinner using `showSpinner()`/`hideSpinner()`. 

### Full-page spinner

You can also use `showPageSpinner()` to show a full-page spinner that will cover the entire page rather than a single Shiny output. Full page spinners support the same parameters as regular spinners, and can be removed with `hidePageSpinner()`.

### Add a message

Use the `caption` parameter to add a custom message under the spinner. The message can either be plain text (`"Please wait"`) or HTML (`div(strong("Loading"), br(), em("Please wait"))`).

### Setting spinner parameters globally

If you want all the spinners in your app to share some of the options, instead of specifying them in each call to `withSpinner()`, you can set them globally using R options. For example, if you want all spinners to be of a certain type and color, you can set `options(spinner.type = 5, spinner.color = "#0dc5c1")`. Similarly, for full-page spinners you can use `page.spinner.type`, `page.spinner.color`, etc to set default parameters instead of setting them in `showPageSpinner()`.

### Showing a spinner on top of the output

By default, the out-dated output gets hidden while the spinner is showing. You can change this behaviour to have the spinner appear on top of the old output using the `hide.ui = FALSE` parameter.

<h2 id="sponsors">

Sponsors 🏆

</h2>

> There are no sponsors yet

{shinycssloaders} is the result of **many** days of work, including many more to come. Show your support and
[become the first sponsor for
{shinycssloaders}\!](https://github.com/sponsors/daattali/sponsorships?tier_id=39856)

## Credits

The 8 built-in animations are taken from [https://projects.lukehaas.me/css-loaders/](https://projects.lukehaas.me/css-loaders/).

The package was originally created by [Andrew Sali](https://github.com/andrewsali).

# [Single Element CSS Spinners](http://projects.lukehaas.me/css-loaders)

This is a collection of loading spinners animated with CSS.

Each spinner consists of a single `div` with a class of `loader` and content text of "Loading...".
The text is for screen readers and can be used as a fallback state for older browsers.

The aim of this project was to create a set of minimal loading spinners that are visually appealing and also convey their intended meaning.

A strict limit of one element per loader (not including pseudo-elements) was placed on this project based on the belief that something as simple as a loader doesn't deserve more.

Each loader is given a font size in pixels and all other sizes are in ems so to change the size of a loader, just adjust the font-size.

## Demo

[![css-loaders-screenshot](https://raw.githubusercontent.com/lukehaas/css-loaders/step2/images/css-loaders-screenshot.jpg)](http://projects.lukehaas.me/css-loaders)

> [Check it live](http://projects.lukehaas.me/css-loaders).

## Browser Support

![IE](https://raw.github.com/alrra/browser-logos/master/internet-explorer/internet-explorer_48x48.png) | ![Chrome](https://raw.github.com/alrra/browser-logos/master/chrome/chrome_48x48.png) | ![Firefox](https://raw.github.com/alrra/browser-logos/master/firefox/firefox_48x48.png) | ![Opera](https://raw.github.com/alrra/browser-logos/master/opera/opera_48x48.png) | ![Safari](https://raw.github.com/alrra/browser-logos/master/safari/safari_48x48.png)
--- | --- | --- | --- | --- |
IE 10+ ✔ | Chrome 4.0+ ✔ | Firefox 16.0+ ✔ | Opera 15.0+ ✔ | Safari 4.0+ ✔ |

## Contributing

1. Fork it!
2. Create your feature branch: `git checkout -b my-new-feature`
3. Commit your changes: `git commit -m 'Add some feature'`
4. Push to the branch: `git push origin my-new-feature`
5. Submit a pull request :)

## History

For detailed changelog, check [Releases](https://github.com/lukehaas/css-loaders/releases).

## License

[MIT License](https://github.com/lukehaas/css-loaders/blob/step2/LICENSE)

#' Show (and hide) a full-page spinner that covers the entire page
#'
#' Use these functions to show and hide a full-page spinner.\cr\cr
#' All parameters (except `expr`) can be set globally in order to use a default setting for all
#' full-page spinner in your Shiny app. This can be done by setting an R option with the parameter's
#' name prepended by `"page.spinner."`. For example, to set all page spinners to type=5 and
#' color=#0dc5c1 by default, use `options(page.spinner.type = 5, page.spinner.color = "#0dc5c1")`.
#' @param expr (optional) An R expression to run while showing the spinner. The
#' spinner will automatically get hidden when this expression completes. If not provided,
#' you must explicitly end the spinner with a call to `hidePageSpinner()`.
#' @param background Background color for the spinner. You can use semi-transparent colours
#' in order to have the Shiny app visible in the background, eg. `"#FFFFFFD0"` or
#' `"rgba(0, 0, 0, 0.7)"`.
#' @inheritParams withSpinner
#' @return If `expr` is provided, the result of `expr` is returned. Otherwise, `NULL`.
#' @seealso [withSpinner()], [showSpinner()], [hideSpinner()]
#' @examples
#' if (interactive()) {
#'   library(shiny)
#'
#'   #--- Example 1: Using showPageSpinner/hidePageSpinner ---
#'
#'   ui <- fluidPage(
#'     actionButton("go", "Go"),
#'     plotOutput("plot")
#'   )
#'   server <- function(input, output) {
#'     observeEvent(input$go, {
#'       showPageSpinner()
#'       Sys.sleep(1)
#'       hidePageSpinner()
#'     })
#'     output$plot <- renderPlot({
#'      plot(runif(10))
#'     })
#'   }
#'   shinyApp(ui, server)
#'
#'   #--- Example 2: Using showPageSpinner with expr ---
#'
#'   some_slow_function <- function() {
#'     Sys.sleep(1)
#'   }
#'
#'   ui <- fluidPage(
#'     actionButton("go", "Go"),
#'     plotOutput("plot")
#'   )
#'   server <- function(input, output) {
#'     observeEvent(input$go, {
#'       showPageSpinner({ some_slow_function() })
#'     })
#'     output$plot <- renderPlot({
#'      plot(runif(10))
#'     })
#'   }
#'   shinyApp(ui, server)
#' }
#' @name showHidePage
NULL

#' @export
#' @rdname showHidePage
showPageSpinner <- function(
    expr,
    background = getOption("page.spinner.background", default = "#FFFFFFCC"),
    type = getOption("page.spinner.type", default = 8),
    color = getOption("page.spinner.color", default = "#0275D8"),
    size = getOption("page.spinner.size", default = 1),
    color.background = getOption("page.spinner.color.background"),
    custom.css = getOption("page.spinner.custom.css", default = FALSE),
    id = getOption("page.spinner.id"),
    image = getOption("page.spinner.image"),
    image.width = getOption("page.spinner.image.width"),
    image.height = getOption("page.spinner.image.height"),
    caption = getOption("page.spinner.caption")
) {

  session <- getSession()
  if (is.null(session$userData$.shinycssloaders_added) || !session$userData$.shinycssloaders_added) {
    shiny::insertUI("head", "beforeEnd", immediate = TRUE, ui = getDependencies())
    session$userData$.shinycssloaders_added <- TRUE
  }

  spinner <- buildSpinner(
    spinner_type = "page",
    type = type,
    color = color,
    size = size,
    color.background = color.background,
    custom.css = custom.css,
    id = id,
    image = image,
    image.width = image.width,
    image.height = image.height,
    caption = caption,
    ui_element = NULL,
    proxy.height = NULL,
    hide.ui = FALSE
  )

  hidePageSpinner()

  spinner_container <- shiny::div(
    id = "shinycssloaders-global-spinner",
    style = paste("background:", background),
    spinner
  )
  shiny::insertUI("body", "beforeEnd", immediate = TRUE, ui = spinner_container)

  if (missing(expr)) {
    value <- invisible(NULL)
  } else {
    value <- expr
    on.exit(hidePageSpinner())
  }

  value
}

#' @export
#' @rdname showHidePage
hidePageSpinner <- function() {
  shiny::removeUI("#shinycssloaders-global-spinner", immediate = TRUE)
  shiny::removeUI(".global-spinner-css", immediate = TRUE)
  invisible(NULL)
}

library(shiny)

share <- list(
  title = "{shinycssloaders} package",
  url = "https://daattali.com/shiny/shinycssloaders-demo/",
  image = "https://daattali.com/shiny/img/shinycssloaders.png",
  description = "Add loading animations to a Shiny output while it's recalculating",
  twitter_user = "daattali"
)

fluidPage(
  shinyjs::useShinyjs(),
  title = paste0("{shinycssloaders} package ", as.character(packageVersion("shinycssloaders"))),
  tags$head(
    includeCSS(file.path('www', 'style.css')),
    # Favicon
    tags$link(rel = "shortcut icon", type="image/x-icon", href="https://daattali.com/shiny/img/favicon.ico"),
    # Facebook OpenGraph tags
    tags$meta(property = "og:title", content = share$title),
    tags$meta(property = "og:type", content = "website"),
    tags$meta(property = "og:url", content = share$url),
    tags$meta(property = "og:image", content = share$image),
    tags$meta(property = "og:description", content = share$description),

    # Twitter summary cards
    tags$meta(name = "twitter:card", content = "summary_large_image"),
    tags$meta(name = "twitter:site", content = paste0("@", share$twitter_user)),
    tags$meta(name = "twitter:creator", content = paste0("@", share$twitter_user)),
    tags$meta(name = "twitter:title", content = share$title),
    tags$meta(name = "twitter:description", content = share$description),
    tags$meta(name = "twitter:image", content = share$image)
  ),

  shinydisconnect::disconnectMessage2(),

  div(
    id = "header",
    div(id = "pagetitle",
        "{shinycssloaders} package"
    ),
    div(id = "subtitle",
        "Add loading animations to a Shiny output while it's recalculating"),
    div(id = "subsubtitle",
        "Maintained by",
        tags$a(href = "https://deanattali.com/", "Dean Attali"),
        HTML("&bull;"),
        "Code",
        tags$a(href = "https://github.com/daattali/shinycssloaders", "on GitHub"),
        HTML("&bull;"),
        tags$a(href = "https://github.com/sponsors/daattali", "Support my work"), "❤"
    )
  ),

  fluidRow(
    column(
      3,
      id = "params",
      selectInput("spinner_type", NULL,
                  c("Spinner on plot output" = "output", "Spinner on entire page" = "page")),
      conditionalPanel(
        "input.spinner_type == 'page'",
        colourpicker::colourInput("bg", "Background", "#222222DD", showColour = "background", allowTransparent = TRUE),
      ),
      selectInput("type", "Spinner type",
                  c("<Custom image>" = "custom", "0 (no spinner)" = "0", 1:8), 8),
      conditionalPanel(
        "input.type == 'custom'",
        textInput(
          "image",
          div("Image URL",
              helpText("Only publicly available URLs are supported in this demo, but you can also use local images in your own apps.")
          ),
          "https://github.com/daattali/shinycssloaders/blob/master/inst/img/custom.gif?raw=true"
        ),
        checkboxInput("image_size_default", "Use original image width/height", TRUE),
        conditionalPanel(
          "input.image_size_default == false",
          fluidRow(
            column(6, numericInput("image.width", "Image width", 100)),
            column(6, numericInput("image.height", "Image height", 100))
          )
        )
      ),
      conditionalPanel(
        "input.type != 'custom'",
        colourpicker::colourInput("col", "Color", "#0275D8", showColour = "background"),
        sliderInput("size", "Size", min = 0.5, max = 5, step = 0.5, value = 1)
      ),
      textInput("caption", "Caption", ""),
      sliderInput("time", "Seconds to show spinner", 0, 3, 1, 0.5),
      conditionalPanel(
        "input.spinner_type == 'output'",
        actionButton("update", "Update Plot", class = "btn-primary btn-lg")
      ),
      conditionalPanel(
        "input.spinner_type == 'page'",
        actionButton("show", "Show Spinner", class = "btn-primary btn-lg")
      )
    ),
    column(
      6,
      uiOutput("show_example")
    )
  )
)

server <- function(input, output, session) {
  plotnum <- reactiveVal(0)
  
  output$show_example <- renderUI({
    if (input$type == "custom") {
      params <- list(
        ui_element = plotOutput(paste0("example", plotnum())),
        image = input$image,
        image.width = if (input$image_size_default) NULL else input$image.width,
        image.height = if (input$image_size_default) NULL else input$image.height
      )
    } else {
      params <- list(
        ui_element = plotOutput(paste0("example", plotnum())),
        type = as.numeric(input$type),
        color = input$col,
        size = input$size,
        color.background = "#fafafa"
      )
    }
    do.call(shinycssloaders::withSpinner, params)
  })
  
  observeEvent(input$update, ignoreNULL = FALSE, {
    plotnum(plotnum() + 1)
    output[[paste0("example", plotnum())]] <- renderPlot({
      bg <- par(bg = "#fafafa")
      shinyjs::disable("params")
      on.exit(shinyjs::enable("params"))
      Sys.sleep(isolate(input$time))
      plot(runif(10), main = "Random Plot")
      bg <- par(bg = bg)
    })
  })
}

library(shiny)
library(shinycssloaders)
library(plotly)

# for spinners 2-3 match the background color of wellPanel
options(spinner.color.background="#F5F5F5")

ui <- fluidPage(
  wellPanel(
    tags$b("This example shows the loading spinner whilst the plot is loading and hides the spinner when the plot is not shown."), 
    br(),br(),
    tags$ul(
      tags$li("You can use it to wrap any kind of output."),
      tags$li("To see what happens on recalculation, click the recalculate button"),
      tags$li("To see what happens if no output should be generated, check off 'Show plots'.")
    ),
    checkboxInput("show_plot","Show plot",value=TRUE),
    actionButton("redraw_plot","Re-draw plots")
  ),
  do.call(tabsetPanel,lapply(1:8,function(.type) {
    tabPanel(paste0("Type ",.type),
             fluidRow(
               column(width=6,
                      wellPanel(
                        tags$b("With spinner:"),
                        withSpinner(plotlyOutput(paste0("plot",.type)),type=.type)
                      )
               ),
               column(width=6,
                      wellPanel(
                        tags$b("Without spinner (default):"),
                        plotlyOutput(paste0("nospin_plot",.type))
                      )
               )
             )
    )
  }))
)

server <- function(input, output,session) {
  for (i in 1:8) {
    output[[paste0("nospin_plot",i)]] <- output[[paste0("plot",i)]] <- renderPlotly({
      validate(need(input$show_plot,"Show plot is unchecked. Check to see plot."))
      input$redraw_plot
      Sys.sleep(5) # just for demo so you can enjoy the animation
      plot_ly(
        x = runif(1e4), y = runif(1e4)
      )
    })
  }
}

shinyApp(ui = ui, server = server)

server <- function(input, output, session) {
  plotnum <- reactiveVal(0)

  spinner_params <- reactive({
    if (input$type == "custom") {
      params <- list(
        ui_element = plotOutput(paste0("example", plotnum())),
        image = input$image,
        image.width = if (input$image_size_default) NULL else input$image.width,
        image.height = if (input$image_size_default) NULL else input$image.height
      )
    } else {
      params <- list(
        ui_element = plotOutput(paste0("example", plotnum())),
        type = as.numeric(input$type),
        color = input$col,
        size = input$size,
        color.background = "#fafafa"
      )
    }

    if (nzchar(input$caption)) {
      params$caption <- input$caption
    }

    params
  })

  output$show_example <- renderUI({
    suppressWarnings(do.call(shinycssloaders::withSpinner, spinner_params()))
  })

  observeEvent(input$update, ignoreNULL = FALSE, {
    plotnum(plotnum() + 1)
    output[[paste0("example", plotnum())]] <- renderPlot({
      bg <- par(bg = "#fafafa")
      shinyjs::disable("params")
      on.exit(shinyjs::enable("params"))
      Sys.sleep(isolate(input$time))
      plot(runif(10), main = "Random Plot")
      bg <- par(bg = bg)
    })
  })

  observeEvent(input$show, {
    params <- spinner_params()
    params$ui_element <- NULL
    params$background <- input$bg
    suppressWarnings(do.call(shinycssloaders::showPageSpinner, params))
    Sys.sleep(input$time)
    hidePageSpinner()
  })
}

#' Add a spinner that shows while an output is recalculating
#'
#' Add a spinner that automatically shows while an output is recalculating. You can also manually trigger the spinner
#' using [showSpinner()] and [hideSpinner()].\cr\cr
#' Most parameters can be set globally in order to use a default setting for all spinners in your Shiny app.
#' This can be done by setting an R option with the parameter's name prepended by `"spinner."`. For example, to set all spinners
#' to type=5 and color=#0dc5c1 by default, use `options(spinner.type = 5, spinner.color = "#0dc5c1")`. The following parameters
#' cannot be set globally: `ui_element`, `id`.\cr\cr
#' Use [showPageSpinner()] to show a spinner on the entire page instead of individual outputs.
#' @param ui_element A UI element that should be wrapped with a spinner when the corresponding output is being calculated.
#' @param type The type of spinner to use. Valid values are integers between 0-8 (0 means no spinner). Check out
#' \url{https://daattali.com/shiny/shinycssloaders-demo/} to see the different types of spinners.
#' You can also use your own custom image using the `image` parameter.
#' @param color The color of the spinner in hex format. Ignored if `image` is used.
#' @param size The size of the spinner, relative to its default size (default is 1, a size of 2 means twice as large).
#' Ignored if `image` is used.
#' @param color.background For certain spinners (type 2-3), you will need to specify the background color of the spinner.
#' Ignored if `image` is used.
#' @param custom.css Set to `TRUE` if you have your own custom CSS that you defined and you don't want the automatic CSS applied to the spinner.
#' Ignored if `image` is used.
#' @param proxy.height If the output UI doesn't specify the output height, you can set a proxy height. It defaults to "400px"
#' for outputs with undefined height. Ignored if `hide.ui` is set to `FALSE`.
#' @param id The HTML ID to use for the spinner. If you don't provide one, it will be generated automatically.
#' @param image The path or URL of the image to use if you want to use a custom image instead of a built-in spinner.
#' If `image` is provided, then `type` is ignored.
#' @param image.height The height for the custom image spinner, in pixels. If not provided, then the original
#' size of the image is used. Ignored if not using `image`.
#' @param image.width The width for the custom image spinner, in pixels. If not provided, then the original
#' size of the image is used. Ignored if not using `image`.
#' @param hide.ui By default, while an output is recalculating, the output UI is hidden and the spinner is visible instead.
#' Setting `hide.ui = FALSE` will result in the spinner showing up on top of the previous output UI.
#' @param caption Caption to display below the spinner or image (text or HTML). The caption's font color is determined
#' by the `color` parameter. Ignored if `type` is 1.
#' @seealso [showSpinner()], [hideSpinner()], [showPageSpinner()]
#' @examples
#' if (interactive()) {
#'   library(shiny)
#'
#'   shinyApp(
#'     ui = fluidPage(
#'       actionButton("go", "Go"),
#'       withSpinner(plotOutput("plot"))
#'     ),
#'     server = function(input, output) {
#'       output$plot <- renderPlot({
#'         input$go
#'         Sys.sleep(1.5)
#'         plot(runif(10))
#'       })
#'     }
#'   )
#' }
#' @export
withSpinner <- function(
  ui_element,
  type = getOption("spinner.type", default = 1),
  color = getOption("spinner.color", default = "#0275D8"),
  size = getOption("spinner.size", default = 1),
  color.background = getOption("spinner.color.background"),
  custom.css = getOption("spinner.custom.css", default = FALSE),
  proxy.height = getOption("spinner.proxy.height"),
  id = NULL,
  image = getOption("spinner.image"),
  image.width = getOption("spinner.image.width"),
  image.height = getOption("spinner.image.height"),
  hide.ui = getOption("spinner.hide.ui", default = TRUE),
  caption = getOption("spinner.caption")
) {

  if (!inherits(ui_element, "shiny.tag") && !inherits(ui_element, "shiny.tag.list")) {
    stop("`ui_element` must be a Shiny tag", call. = FALSE)
  }

  spinner <- buildSpinner(
    spinner_type = "output",
    ui_element = ui_element,
    type = type,
    color = color,
    size = size,
    color.background = color.background,
    custom.css = custom.css,
    proxy.height = proxy.height,
    id = id,
    image = image,
    image.width = image.width,
    image.height = image.height,
    hide.ui = hide.ui,
    caption = caption
  )

  htmltools::attachDependencies(spinner, getDependencies())
}

# get the shiny session object
getSession <- function() {
  session <- shiny::getDefaultReactiveDomain()

  if (is.null(session)) {
    stop("Could not find the Shiny session object. This usually happens if you're trying to call a function outside of a Shiny app.", call. = FALSE)
  }

  session
}

# insert content into the <head> tag of the document if this is a proper
# Shiny app, but if it's inside an interactive Rmarkdown document then don't
# use <head> as it won't work
insertHead <- function(...) {
  if (requireNamespace("knitr", quietly = TRUE)) {
    runtime <- knitr::opts_knit$get("rmarkdown.runtime")
    if (!is.null(runtime) && runtime == "shiny") {
      # we're inside an Rmd document
      shiny::tagList(...)
    } else {
      # we're in a shiny app
      shiny::tags$head(...)
    }
  } else {
    # we're in a shiny app
    shiny::tags$head(...)
  }

}

getDependencies <- function() {
  list(
    htmltools::htmlDependency(
      name = "shinycssloaders-binding",
      version = as.character(utils::packageVersion("shinycssloaders")),
      package = "shinycssloaders",
      src = "assets",
      script = "spinner.js",
      stylesheet = "spinner.css"
    )
  )
}

get_proxy_element <- function(ui_element, proxy.height, hide.ui) {
  if (!hide.ui) {
    return(shiny::tagList())
  }

  if (is.null(proxy.height)) {
    if (!grepl("height:\\s*\\d", ui_element)) {
      proxy.height <- "400px"
    }
  } else {
    if (is.numeric(proxy.height)) {
      proxy.height <- paste0(proxy.height, "px")
    }
  }

  if (is.null(proxy.height)) {
    proxy_element <- shiny::tagList()
  } else {
    proxy_element <- shiny::div(style=glue::glue("height:{proxy.height}"),
                                class="shiny-spinner-placeholder")
  }
}

get_spinner_css_tag <- function(type, color, size, color.background, custom.css, id, image, caption, output_spinner) {
  base_css <- ""
  add_default_style <- (is.null(image) && !custom.css && type != 0)
  if (add_default_style) {
    if (type %in% c(2, 3) && is.null(color.background)) {
      stop("shinycssloaders: For spinner types 2 & 3 you need to specify `color.background`.")
    }

    color.rgb <- paste(grDevices::col2rgb(color), collapse = ",")
    color.alpha0 <- sprintf("rgba(%s, 0)", color.rgb)
    color.alpha2 <- sprintf("rgba(%s, 0.2)", color.rgb)

    css_file <- system.file(glue::glue("loaders-templates/load{type}.css"), package="shinycssloaders")
    if (file.exists(css_file)) {
      base_css <- paste(readLines(css_file), collapse = " ")
      base_css <- glue::glue(base_css, .open = "{{", .close = "}}")
    }

    # get default font-size from css, and cut it by 25%, as for outputs we usually need something smaller
    size_px <- round(c(11, 11, 10, 20, 25, 90, 10, 10)[type] * size * 0.75)
    base_css <- paste(base_css, glue::glue("#{id} {{ font-size: {size_px}px; }}"))
  }

  if (!is.null(caption)) {
    base_css <- paste(base_css, glue::glue("#{id}__caption {{ color: {color}; font-size: {size + 0.5}em; }}"))
  }

  css_rules_tag <- NULL
  if (nzchar(base_css)) {
    css_rules_tag <- insertHead(shiny::tags$style(
      class = if (!output_spinner) "global-spinner-css",
      shiny::HTML(base_css)
    ))
  }
  css_rules_tag
}

library(shiny)

share <- list(
  title = "{shinycssloaders} package",
  url = "https://daattali.com/shiny/shinycssloaders-demo/",
  image = "https://daattali.com/shiny/img/shinycssloaders.png",
  description = "Add loading animations to a Shiny output while it's recalculating",
  twitter_user = "daattali"
)

fluidPage(
  shinyjs::useShinyjs(),
  title = paste0("{shinycssloaders} package ", as.character(packageVersion("shinycssloaders"))),
  tags$head(
    includeCSS(file.path('www', 'style.css')),
    # Favicon
    tags$link(rel = "shortcut icon", type="image/x-icon", href="https://daattali.com/shiny/img/favicon.ico"),
    # Facebook OpenGraph tags
    tags$meta(property = "og:title", content = share$title),
    tags$meta(property = "og:type", content = "website"),
    tags$meta(property = "og:url", content = share$url),
    tags$meta(property = "og:image", content = share$image),
    tags$meta(property = "og:description", content = share$description),
    
    # Twitter summary cards
    tags$meta(name = "twitter:card", content = "summary_large_image"),
    tags$meta(name = "twitter:site", content = paste0("@", share$twitter_user)),
    tags$meta(name = "twitter:creator", content = paste0("@", share$twitter_user)),
    tags$meta(name = "twitter:title", content = share$title),
    tags$meta(name = "twitter:description", content = share$description),
    tags$meta(name = "twitter:image", content = share$image)
  ),
  
  shinydisconnect::disconnectMessage2(),
  
  div(
    id = "header",
    div(id = "pagetitle",
        "{shinycssloaders} package"
    ),
    div(id = "subtitle",
        "Add loading animations to a Shiny output while it's recalculating"),
    div(id = "subsubtitle",	
        "Maintained by",	
        tags$a(href = "https://deanattali.com/", "Dean Attali"),	
        HTML("&bull;"),	
        "Code",	
        tags$a(href = "https://github.com/daattali/shinycssloaders", "on GitHub"),	
        HTML("&bull;"),	
        tags$a(href = "https://github.com/sponsors/daattali", "Support my work"), "❤"	
    )
  ),
  
  fluidRow(
    column(
      3,
      id = "params",
      selectInput("type", "Spinner type",
                  c("<Custom image>" = "custom", "0 (no spinner)" = "0", 1:8), 1),
      conditionalPanel(
        "input.type == 'custom'",
        textInput(
          "image",
          div("Image URL", 
              helpText("Only publicly available URLs are supported in this demo, but you can also use local images in your own apps.")
          ),
          "https://github.com/daattali/shinycssloaders/blob/master/inst/img/custom.gif?raw=true"
        ),
        checkboxInput("image_size_default", "Use original image width/height", TRUE),
        conditionalPanel(
          "input.image_size_default == false",
          fluidRow(
            column(6, numericInput("image.width", "Image width", 100)),
            column(6, numericInput("image.height", "Image height", 100))
          )
        )
      ),
      conditionalPanel(
        "input.type != 'custom'",
        colourpicker::colourInput("col", "Color", "#0275D8", showColour = "background"),
        sliderInput("size", "Size", min = 0.5, max = 5, step = 0.5, value = 1)
      ),
      numericInput("time", "Seconds to show spinner", 1.5),
      actionButton("update", "Update", class = "btn-primary btn-lg"),
    ),
    column(
      6,
      uiOutput("show_example")
    )
  )
)

#' shinycssloaders
#'
#' Add automatic loading animations to your Shiny outputs (e.g. plots, tables) by adding a single function call 
#' around the Shiny output function. Animations automatically show/hide when the output 
#' is recalculating/recalculated. You can use your own custom image, or choose from 8 different types of 
#' built-in animations, as well customize the color and size of the built-in animations.
#' 
#' For further reference on how to use the package, please refer to \url{https://github.com/daattali/shinycssloaders}
#' 
#' @name shinycssloaders
#' @docType package
NULL

buildSpinner <- function(
    spinner_type = c("output", "page"),
    ui_element,
    type,
    color,
    size,
    color.background,
    custom.css,
    proxy.height,
    id,
    image,
    image.width,
    image.height,
    hide.ui,
    caption
) {
  spinner_type <- match.arg(spinner_type)
  output_spinner <- (spinner_type == "output")

  if (!is.null(image)) {
    type <- 0
  }
  if (!type %in% 0:8) {
    stop("shinycssloaders: `type` must be an integer between 0 and 8.")
  }
  if (grepl("rgb", color, fixed = TRUE)) {
    stop("shinycssloaders: `color` should be given in hex format (#XXXXXX).")
  }
  if (is.character(custom.css)) {
    stop("shinycssloaders: It looks like you provided a string to `custom.css`, but it needs to be either `TRUE` or `FALSE`. ",
         "The actual CSS needs to added to the app's UI.")
  }

  if (is.null(id)) {
    id <- paste0("spinner-", digest::digest(ui_element))
  }

  css_rules_tag <- get_spinner_css_tag(type, color, size, color.background, custom.css, id, image, caption, output_spinner)

  if (!is.null(caption)) {
    caption <- shiny::div(
      id = paste0(id, "__caption"),
      class = "shiny-spinner-caption",
      caption
    )
  }

  if (output_spinner) {
    proxy_element <- get_proxy_element(ui_element, proxy.height, hide.ui)
  } else {
    proxy_element <- NULL
  }

  parent_cls <- "shiny-spinner-output-container"
  if (hide.ui) {
    parent_cls <- paste(parent_cls, "shiny-spinner-hideui")
  }

  child_cls <- "load-container"
  if (output_spinner) {
    child_cls <- paste(child_cls, "shiny-spinner-hidden")
  }
  if (is.null(image)) {
    child_cls <- paste(child_cls, paste0("load", type))
  }

  if (is.null(image)) {
    spinner_el <- shiny::div(id = id, class = "loader",
                             (if (type == 0) "" else "Loading..."))
  } else {
    spinner_el <- shiny::tags$img(id = id, src = image, alt = "Loading...",
                                  width = image.width, height = image.height)
  }

  shiny::div(
    css_rules_tag,
    `data-spinner-id` = id,
    class = parent_cls,
    shiny::div(
      class = child_cls,
      spinner_el,
      caption
    ),
    proxy_element,
    ui_element
  )
}

#' Manually show/hide a spinner
#'
#' Any Shiny output that uses [withSpinner()] will automatically show a spinner
#' while it's recalculating. Use [showSpinner()] and [hideSpinner()] to manually
#' trigger the spinner on-demand.
#' @param id The ID of the Shiny output. The corresponding output must have been
#' wrapped in [withSpinner()] in the UI.
#' @param expr (optional) An R expression to run while showing the spinner. The
#' spinner will automatically get hidden when this expression completes.
#' @return If `expr` is provided, the result of `expr` is returned. Otherwise, `NULL`.
#' @seealso [withSpinner()]
#' @examples
#' if (interactive()) {
#'   library(shiny)
#'
#'   #--- Example 1: Using showSpinner/hideSpinner ---
#'
#'   shinyApp(
#'     ui = fluidPage(
#'       actionButton("show", "Show"),
#'       actionButton("hide", "Hide"),
#'       withSpinner(plotOutput("plot"))
#'     ),
#'     server = function(input, output) {
#'       output$plot <- renderPlot({
#'         plot(runif(10))
#'       })
#'       observeEvent(input$show, {
#'         showSpinner("plot")
#'       })
#'       observeEvent(input$hide, {
#'         hideSpinner("plot")
#'       })
#'     }
#'   )
#'
#'   #--- Example 2: Using showSpinner with expr ---
#'
#'   some_slow_function <- function() {
#'     Sys.sleep(2)
#'   }
#'
#'   shinyApp(
#'     ui = fluidPage(
#'       actionButton("show", "Show"),
#'       withSpinner(plotOutput("plot"))
#'     ),
#'     server = function(input, output) {
#'       output$plot <- renderPlot({
#'         plot(runif(10))
#'       })
#'       observeEvent(input$show, {
#'         showSpinner("plot", { some_slow_function() })
#'       })
#'     }
#'   )
#' }
#' @name showHide
NULL

#' @export
#' @rdname showHide
showSpinner <- function(id, expr) {
  session <- getSession()

  idns <- session$ns(id)
  session$sendCustomMessage("shinycssloaders.show_spinner",  list(id = idns))

  if (missing(expr)) {
    value <- invisible(NULL)
  } else {
    value <- expr
    on.exit(hideSpinner(id))
  }

  value
}

#' @export
#' @rdname showHide
hideSpinner <- function(id) {
  session <- getSession()

  idns <- session$ns(id)
  session$sendCustomMessage("shinycssloaders.hide_spinner", list(id = idns))

  invisible(NULL)
}

library(shiny)
library(shinycssloaders)
library(DT)

# for spinners 2-3 match the background color of wellPanel
options(spinner.color.background="#F5F5F5")

ui <- fluidPage(
  wellPanel(
    tags$b("This example shows the loading spinner whilst a data-table is loading and hides the spinner when the data-table is not shown."), 
    br(),
    br(),
    tags$b(style="color:red","Since the table height is not known ex-ante (as it depends on the rows selected), we insert a 'proxy' container that emulates the unknown table. The spinner is centered with respect to the proxy. The proxy height is configurable and should in general represent an 'expected' output height."),
    br(),
    br(),
    tags$ul(
      tags$li("You can use it to wrap any kind of output."),
      tags$li("To see what happens on recalculation, click the recalculate button"),
      tags$li("To see what happens if no output should be generated, check off 'Show plots'.")
    ),
    checkboxInput("show_plot","Show tables",value=TRUE),
    actionButton("redraw_plot","Re-draw tables"),
    br(),
    br(),
    fluidRow(
      column(
        sliderInput("n_rows","Number of rows in table",min=1,max=nrow(mtcars),value=10,step = 1),
        width=3)
    )
  ),
  do.call(tabsetPanel,lapply(1:8,function(.type) {
    tabPanel(paste0("Type ",.type),
             fluidRow(
               column(width=6,
                      wellPanel(
                        tags$b("With spinner:"),
                        withSpinner(tableOutput(paste0("table",.type)),type=.type) 
                      )
               ),
               column(width=6,
                      wellPanel(
                        tags$b("Without spinner (default):"),
                        tableOutput(paste0("nospin_table",.type))
                      )
               )
             )
    )
  }))
)

server <- function(input, output,session) {
  for (i in 1:8) {
    output[[paste0("nospin_table",i)]] <- output[[paste0("table",i)]] <- renderTable({
      validate(need(input$show_plot,"Show table is unchecked. Check to see table."))
      input$redraw_plot
      Sys.sleep(5) # just for demo so you can enjoy the animation
      mtcars[1:input$n_rows,]
    })
  }
}

shinyApp(ui = ui, server = server)

.onLoad <- function(libname, pkgname) {
  shiny::addResourcePath(prefix = "assets",directoryPath = system.file("assets",package="shinycssloaders"))
  shiny::addResourcePath(prefix = "css-loaders",directoryPath = system.file("css-loaders",package="shinycssloaders"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shinycssloaders-package.r
\docType{package}
\name{shinycssloaders}
\alias{shinycssloaders}
\title{shinycssloaders}
\description{
Add automatic loading animations to your Shiny outputs (e.g. plots, tables) by adding a single function call
around the Shiny output function. Animations automatically show/hide when the output
is recalculating/recalculated. You can use your own custom image, or choose from 8 different types of
built-in animations, as well customize the color and size of the built-in animations.
}
\details{
For further reference on how to use the package, please refer to \url{https://github.com/daattali/shinycssloaders}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shinycssloaders-package.r
\docType{package}
\name{shinycssloaders-package}
\alias{shinycssloaders}
\alias{shinycssloaders-package}
\title{shinycssloaders: Add Loading Animations to a 'shiny' Output While It's Recalculating}
\description{
When a 'Shiny' output (such as a plot, table, map, etc.) is recalculating, it remains visible but gets greyed out. Using 'shinycssloaders', you can add a loading animation ("spinner") to outputs instead. By wrapping a 'Shiny' output in 'withSpinner()', a spinner will automatically appear while the output is recalculating. You can also manually show and hide the spinner, or add a full-page spinner to cover the entire page. See the demo online at \url{https://daattali.com/shiny/shinycssloaders-demo/}.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/daattali/shinycssloaders}
  \item \url{https://daattali.com/shiny/shinycssloaders-demo/}
  \item Report bugs at \url{https://github.com/daattali/shinycssloaders/issues}
}

}
\author{
\strong{Maintainer}: Dean Attali \email{daattali@gmail.com} (\href{https://orcid.org/0000-0002-5645-3493}{ORCID}) (Maintainer/developer of shinycssloaders since 2019)

Authors:
\itemize{
  \item Andras Sali \email{andras.sali@alphacruncher.hu} (Original creator of shinycssloaders package)
}

Other contributors:
\itemize{
  \item Luke Hass (Author of included CSS loader code) [contributor, copyright holder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/withSpinner.R
\name{withSpinner}
\alias{withSpinner}
\title{Add a spinner that shows when an output is recalculating}
\usage{
withSpinner(
  ui_element,
  type = getOption("spinner.type", default = 1),
  color = getOption("spinner.color", default = "#0275D8"),
  size = getOption("spinner.size", default = 1),
  color.background = getOption("spinner.color.background"),
  custom.css = FALSE,
  proxy.height = NULL,
  id = NULL,
  image = NULL,
  image.width = NULL,
  image.height = NULL,
  hide.ui = TRUE
)
}
\arguments{
\item{ui_element}{A UI element that should be wrapped with a spinner when the corresponding output is being calculated.}

\item{type}{The type of spinner to use, valid values are integers between 0-8 (0 means no spinner). Check out
\url{https://daattali.com/shiny/shinycssloaders-demo} to see the different types of spinners. You can also use
your own custom image using the \code{image} parameter.}

\item{color}{The color of the spinner in hex format. Ignored if \code{image} is used.}

\item{size}{The size of the spinner, relative to its default size (default is 1, a size of 2 means twice as large). Ignored if \code{image} is used.}

\item{color.background}{For certain spinners (type 2-3), you will need to specify the background color of the spinner. Ignored if \code{image} is used.}

\item{custom.css}{Set to \code{TRUE} if you have your own custom CSS that you defined and you don't want the automatic CSS applied to the spinner. Ignored if \code{image} is used.}

\item{proxy.height}{If the output UI doesn't specify the output height, you can set a proxy height. It defaults to "400px"
for outputs with undefined height. Ignored if \code{hide.ui} is set to \code{FALSE}.}

\item{id}{The HTML ID to use for the spinner. If you don't provide one, it will be generated automatically.}

\item{image}{The path or URL of the image to use if you want to use a custom image instead of a built-in spinner.}

\item{image.width}{The width for the custom image spinner, in pixels. If not provided, then the original
size of the image is used. Ignored if not using \code{image}.}

\item{image.height}{The height for the custom image spinner, in pixels. If not provided, then the original
size of the image is used. Ignored if not using \code{image}.}

\item{hide.ui}{By default, while an output is recalculating, the output UI is hidden and the spinner is visible instead.
Setting \code{hide.ui = FALSE} will result in the spinner showing up on top of the previous output UI.}
}
\description{
Add a spinner that shows when an output is recalculating
}
\examples{
if (interactive()) {
  library(shiny)

  shinyApp(
    ui = fluidPage(
      actionButton("go", "Go"),
      withSpinner(plotOutput("plot"))
    ),
    server = function(input, output) {
      output$plot <- renderPlot({
        input$go
        Sys.sleep(1.5)
        plot(runif(10))
      })
    }
  )
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/show-hide.R
\name{showHide}
\alias{showHide}
\alias{showSpinner}
\alias{hideSpinner}
\title{Manually show/hide a spinner}
\usage{
showSpinner(id, expr)

hideSpinner(id)
}
\arguments{
\item{id}{The ID of the Shiny output. The corresponding output must have been
wrapped in \code{\link[=withSpinner]{withSpinner()}} in the UI.}

\item{expr}{(optional) An R expression to run while showing the spinner. The
spinner will automatically get hidden when this expression completes.}
}
\value{
If \code{expr} is provided, the result of \code{expr} is returned. Otherwise, \code{NULL}.
}
\description{
Any Shiny output that uses \code{\link[=withSpinner]{withSpinner()}} will automatically show a spinner
while it's recalculating. Use \code{\link[=showSpinner]{showSpinner()}} and \code{\link[=hideSpinner]{hideSpinner()}} to manually
trigger the spinner on-demand.
}
\examples{
if (interactive()) {
  library(shiny)

  #--- Example 1: Using showSpinner/hideSpinner ---

  shinyApp(
    ui = fluidPage(
      actionButton("show", "Show"),
      actionButton("hide", "Hide"),
      withSpinner(plotOutput("plot"))
    ),
    server = function(input, output) {
      output$plot <- renderPlot({
        plot(runif(10))
      })
      observeEvent(input$show, {
        showSpinner("plot")
      })
      observeEvent(input$hide, {
        hideSpinner("plot")
      })
    }
  )

  #--- Example 2: Using showSpinner with expr ---

  some_slow_function <- function() {
    Sys.sleep(2)
  }

  shinyApp(
    ui = fluidPage(
      actionButton("show", "Show"),
      withSpinner(plotOutput("plot"))
    ),
    server = function(input, output) {
      output$plot <- renderPlot({
        plot(runif(10))
      })
      observeEvent(input$show, {
        showSpinner("plot", { some_slow_function() })
      })
    }
  )
}
}
\seealso{
\code{\link[=withSpinner]{withSpinner()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pageSpinner.R
\name{showHidePage}
\alias{showHidePage}
\alias{showPageSpinner}
\alias{hidePageSpinner}
\title{Show (and hide) a full-page spinner that covers the entire page}
\usage{
showPageSpinner(
  expr,
  background = getOption("page.spinner.background", default = "#FFFFFFCC"),
  type = getOption("page.spinner.type", default = 8),
  color = getOption("page.spinner.color", default = "#0275D8"),
  size = getOption("page.spinner.size", default = 1),
  color.background = getOption("page.spinner.color.background"),
  custom.css = getOption("page.spinner.custom.css", default = FALSE),
  id = getOption("page.spinner.id"),
  image = getOption("page.spinner.image"),
  image.width = getOption("page.spinner.image.width"),
  image.height = getOption("page.spinner.image.height"),
  caption = getOption("page.spinner.caption")
)

hidePageSpinner()
}
\arguments{
\item{expr}{(optional) An R expression to run while showing the spinner. The
spinner will automatically get hidden when this expression completes. If not provided,
you must explicitly end the spinner with a call to \code{hidePageSpinner()}.}

\item{background}{Background color for the spinner. You can use semi-transparent colours
in order to have the Shiny app visible in the background, eg. \code{"#FFFFFFD0"} or
\code{"rgba(0, 0, 0, 0.7)"}.}

\item{type}{The type of spinner to use. Valid values are integers between 0-8 (0 means no spinner). Check out
\url{https://daattali.com/shiny/shinycssloaders-demo/} to see the different types of spinners.
You can also use your own custom image using the \code{image} parameter.}

\item{color}{The color of the spinner in hex format. Ignored if \code{image} is used.}

\item{size}{The size of the spinner, relative to its default size (default is 1, a size of 2 means twice as large).
Ignored if \code{image} is used.}

\item{color.background}{For certain spinners (type 2-3), you will need to specify the background color of the spinner.
Ignored if \code{image} is used.}

\item{custom.css}{Set to \code{TRUE} if you have your own custom CSS that you defined and you don't want the automatic CSS applied to the spinner.
Ignored if \code{image} is used.}

\item{id}{The HTML ID to use for the spinner. If you don't provide one, it will be generated automatically.}

\item{image}{The path or URL of the image to use if you want to use a custom image instead of a built-in spinner.
If \code{image} is provided, then \code{type} is ignored.}

\item{image.width}{The width for the custom image spinner, in pixels. If not provided, then the original
size of the image is used. Ignored if not using \code{image}.}

\item{image.height}{The height for the custom image spinner, in pixels. If not provided, then the original
size of the image is used. Ignored if not using \code{image}.}

\item{caption}{Caption to display below the spinner or image (text or HTML). The caption's font color is determined
by the \code{color} parameter. Ignored if \code{type} is 1.}
}
\value{
If \code{expr} is provided, the result of \code{expr} is returned. Otherwise, \code{NULL}.
}
\description{
Use these functions to show and hide a full-page spinner.\cr\cr
All parameters (except \code{expr}) can be set globally in order to use a default setting for all
full-page spinner in your Shiny app. This can be done by setting an R option with the parameter's
name prepended by \code{"page.spinner."}. For example, to set all page spinners to type=5 and
color=#0dc5c1 by default, use \code{options(page.spinner.type = 5, page.spinner.color = "#0dc5c1")}.
}
\examples{
if (interactive()) {
  library(shiny)

  #--- Example 1: Using showPageSpinner/hidePageSpinner ---

  ui <- fluidPage(
    actionButton("go", "Go"),
    plotOutput("plot")
  )
  server <- function(input, output) {
    observeEvent(input$go, {
      showPageSpinner()
      Sys.sleep(1)
      hidePageSpinner()
    })
    output$plot <- renderPlot({
     plot(runif(10))
    })
  }
  shinyApp(ui, server)

  #--- Example 2: Using showPageSpinner with expr ---

  some_slow_function <- function() {
    Sys.sleep(1)
  }

  ui <- fluidPage(
    actionButton("go", "Go"),
    plotOutput("plot")
  )
  server <- function(input, output) {
    observeEvent(input$go, {
      showPageSpinner({ some_slow_function() })
    })
    output$plot <- renderPlot({
     plot(runif(10))
    })
  }
  shinyApp(ui, server)
}
}
\seealso{
\code{\link[=withSpinner]{withSpinner()}}, \code{\link[=showSpinner]{showSpinner()}}, \code{\link[=hideSpinner]{hideSpinner()}}
}
